%define srcname %{name}-libs

%global _smp_ncpus_max 1

%define lib_major_xcompshad 3
%define lib_name_xcompshad %mklibname xcompshad %{lib_major_xcompshad}

%define lib_major_nxx11 6
%define lib_name_nxx11 %mklibname nxX11_ %{lib_major_nxx11}

%define lib_major_xcomp 3
%define lib_name_xcomp %mklibname xcomp %{lib_major_xcomp}

Name:		nx
Version:	3.5.99.27
Release:	%mkrel 1
Summary:	NX core libraries
License:	GPLv2
Group:		Networking/Remote access
Url:		https://github.com/ArcticaProject/nx-libs
Source0:	https://github.com/ArcticaProject/nx-libs/archive/%{version}/%{name}-libs-%{version}.tar.gz
# https://github.com/ArcticaProject/nx-libs/pull/1087
Patch1:		nx-3.5.99.26-gcc14-32bit.patch
Patch2:		nx-3.5.99.26-gcc14-access.patch
# https://github.com/ArcticaProject/nx-libs/issues/1044
Patch3:		nx-3.5.99.26-clang-bind.patch

BuildRequires:	autoconf
BuildRequires:	gcc-c++
BuildRequires:	gccmakedep
BuildRequires:	imake
BuildRequires:	pkgconfig(libjpeg)
BuildRequires:	pkgconfig(libpng)
BuildRequires:	pkgconfig(zlib)
BuildRequires:	pkgconfig(liblzma)
BuildRequires:	pkgconfig(fontenc)
BuildRequires:	pkgconfig(libxml-2.0)
BuildRequires:	pkgconfig(xproto)
BuildRequires:	pkgconfig(libtirpc)
BuildRequires:	pkgconfig(xcomposite)
BuildRequires:	pkgconfig(xdamage)
BuildRequires:	pkgconfig(xdmcp)
BuildRequires:	pkgconfig(xfixes)
BuildRequires:	pkgconfig(xfont2)
BuildRequires:	pkgconfig(xinerama)
BuildRequires:	pkgconfig(xpm)
BuildRequires:	pkgconfig(xrandr)
BuildRequires:	pkgconfig(xtst)
BuildRequires:	pkgconfig(xkbcomp)
BuildRequires:	pkgconfig(fontutil)
BuildRequires:	pixman-devel
BuildRequires:	python3-devel
BuildRequires:	quilt

%description
NoMachine NX is the next-generation X compression and round-trip
suppression scheme. It can operate remote X11 sessions over 
56k modem dial-up links or anything better.
This package uses the patched and redistributed sources from the
x2go project.

%package -n	%{lib_name_nxx11}
Summary: 	Nx-X11 lib for NX
Group:		System/Libraries
Provides:	nxX11 = %{version}-%{release}

%description -n	%{lib_name_nxx11}
NX-X11 lib for the NX framework

%package -n	%{lib_name_xcomp}
Summary:	Xcomp library for NX
Group:		System/Libraries
Provides:	xcomp = %{version}-%{release}

%description -n	%{lib_name_xcomp}
Xcomp library for NX subsystem

%package -n	%{lib_name_xcompshad}
Summary: 	Xcompshad library for NX
Group:		System/Libraries
Provides:	xcompext = %{version}-%{release}
Provides:	xcompshad = %{version}-%{release}

%description -n	%{lib_name_xcompshad}
Xcompshad library needed by the NX framework

%package -n  	nxproxy
Summary: 	Provide the protocol compression and caching part of the NX scheme
Group:		Networking/Remote access

%description -n	nxproxy
The nxproxy runs on the X server side of the wire and thus accompanies 
the nxagent running on X client side. It provides the protocol
compression and caching part of the NX scheme.

%package -n	nxagent
Summary: 	NX X server based on Xnest
Group:		Networking/Remote access
Recommends:	x11-data-xkbdata
Provides:	x2goagent = %{version}-%{release}
Obsoletes:	x2goagent < 3.5.99.0-1

%description -n	nxagent
The nxagent is an X server based on Xnest, but modified
for the purpose of reducing roundtrips over high-latency
networks significantly. It is run on the client side of X,
that is, on the machine where X clients run. It connects,
over the wire, to your regular X server, possibly through nxproxy.

%package -n	nxdialog
Summary: 	NX Dialog
Group:		Networking/Remote access

%description -n	nxdialog
NX is a software suite which implements very efficient compression of
the X11 protocol. This increases performance when using X
applications over a network, especially a slow one.

This package provides the nxdialog helper script.


%prep
%autosetup -p1 -n %{srcname}-%{version}

# Fix prefix, libdir etc
sed -i -e '/ProjectRoot/s|/usr/local|%{_prefix}|g' nx-X11/config/cf/site.def
sed -i -e 's|/usr/local/lib|%{_libdir}|g' \
       -e 's|/usr/local|%{_prefix}|g' \
       -e '/LibDirName/s|lib$|%{_lib}|g' \
       nx-X11/config/cf/Imake.tmpl

$(rpm --eval '%%configure "${@}"'> tmp_configure)
chmod a+x tmp_configure

%build
%make_build \
  CONFIGURE="$PWD/tmp_configure" \
  PREFIX=%{_prefix} \
  LIBDIR=%{_libdir} \
  IMAKE_DEFINES="-DUseTIRPC=YES"

%install
%make_install \
    PREFIX=%{_prefix} \
    LIBDIR=%{_libdir} \
    INSTALL_DIR="install -dm0755" \
    INSTALL_FILE="install -pm0644" \
    INSTALL_PROGRAM="install -pm0755"

ln -s ../X11/fonts %{buildroot}%{_datadir}/nx/fonts

# Fix permissions on shared libraries
chmod 755  %{buildroot}%{_libdir}/lib*.so*

# Remove unneeded headers and development files
rm -rf %{buildroot}%{_includedir}
rm -f %{buildroot}%{_libdir}/*.so %{buildroot}%{_libdir}/pkgconfig/*.pc

#Remove static libs and our shared libraries' .la files
rm -f %{buildroot}%{_libdir}/*.{a,la}

# Fix python scripts
%py3_shebang_fix %{buildroot}%{_bindir}/nxdialog

%files -n nxagent
%license COPYING LICENSE LICENSE.nxcomp
%doc ChangeLog doc/nxagent/README.keystrokes
%dir %{_sysconfdir}/nxagent
%config(noreplace) %{_sysconfdir}/nxagent/keystrokes.cfg
%attr(0755,root,root) %{_bindir}/nxagent
%dir %{_libdir}/nx
%dir %{_libdir}/nx/bin
%{_libdir}/nx/bin/nxagent
%dir %{_datadir}/nx
%{_datadir}/nx/fonts
%{_datadir}/nx/VERSION.nxagent
%{_datadir}/nx/SecurityPolicy
%dir %{_datadir}/nx/X11
%{_datadir}/nx/X11/XErrorDB
%{_datadir}/nx/X11/Xcms.txt
%{_mandir}/man1/nxagent.1*

%files -n nxproxy
%attr(0755,root,root) %{_bindir}/nxproxy
%dir %{_datadir}/nx
%{_datadir}/nx/VERSION.nxproxy
%{_mandir}/man1/nxproxy.1*

%files -n nxdialog
%doc nxdialog/README.md
%{_bindir}/nxdialog
%{_mandir}/man1/nxdialog.1*

%files -n  %{lib_name_nxx11}
%{_libdir}/libNX_X11.so.%{lib_major_nxx11}*
%dir %{_libdir}/nx/X11
%{_libdir}/nx/X11/libX11.so.%{lib_major_nxx11}*

%files -n %{lib_name_xcomp}
%{_libdir}/libXcomp.so.%{lib_major_xcomp}*

%files -n  %{lib_name_xcompshad}
%{_libdir}/libXcompshad.so.%{lib_major_xcompshad}*


%changelog
* Thu Jul 10 2025 daviddavid <daviddavid> 3.5.99.27-1.mga10
+ Revision: 2252649
- new version: 3.5.99.27
- add gentoo patches to fix 32bit build
+ umeabot <umeabot>
- Mageia 10 Mass Rebuild
+ wally <wally>
- rebuild for libxml2 2.13.6

* Sun Jan 01 2023 wally <wally> 3.5.99.26-3.mga9
+ Revision: 1928676
- more prefix and libdir fixes

* Sun Jan 01 2023 wally <wally> 3.5.99.26-2.mga9
+ Revision: 1928658
- fix PREFIX and LIBDIR
- add missing BRs

* Sat Aug 27 2022 obgr_seneca <obgr_seneca> 3.5.99.26-1.mga9
+ Revision: 1881277
- Update to new version 3.5.99.26
+ umeabot <umeabot>
- Mageia 9 Mass Rebuild

* Sun Dec 06 2020 luigiwalser <luigiwalser> 3.5.99.25-1.mga8
+ Revision: 1653282
- 3.5.99.25 (partial sync with fedora)
- update URLs
- obsolete x2goagent
- add nxdialog subpackage
- disable parallel make for now
- build with libtirpc
- try to build with libtirpc
- unobsolete nx

* Sat Feb 15 2020 umeabot <umeabot> 3.5.0.33-4.mga8
+ Revision: 1525552
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%makeinstall_std

* Fri Apr 19 2019 daviddavid <daviddavid> 3.5.0.33-3.mga7
+ Revision: 1393340
- add patch to fix build with new fontenc

* Sun Sep 23 2018 umeabot <umeabot> 3.5.0.33-2.mga7
+ Revision: 1299819
- Mageia 7 Mass Rebuild
+ kekepower <kekepower>
- Use make_build

* Mon Mar 12 2018 kekepower <kekepower> 3.5.0.33-1.mga7
+ Revision: 1208511
- Update to version 3.5.0.33
- This fixes CVE-2017-2624 (mga#22734)

* Tue Jan 17 2017 ghibo <ghibo> 3.5.0.32-1.mga6
+ Revision: 1082201
- Added xproto-devel to BuildRequires.
- Update to release 3.5.0.32.
- Fix mix of tabs and spaces in SPEC file.

* Wed Feb 17 2016 umeabot <umeabot> 3.5.0.22-4.mga6
+ Revision: 964532
- Mageia 6 Mass Rebuild

* Wed Oct 15 2014 umeabot <umeabot> 3.5.0.22-3.mga5
+ Revision: 747213
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 3.5.0.22-2.mga5
+ Revision: 682958
- Mageia 5 Mass Rebuild

* Sat Feb 08 2014 dams <dams> 3.5.0.22-1.mga5
+ Revision: 585707
- new version 3.5.0.22

* Sat Oct 19 2013 umeabot <umeabot> 3.5.0.16-6.mga4
+ Revision: 526019
- Mageia 4 Mass Rebuild

* Mon Jun 03 2013 fwang <fwang> 3.5.0.16-5.mga4
+ Revision: 435510
- rebuild for new libpng

* Sun Jan 13 2013 barjac <barjac> 3.5.0.16-4.mga3
+ Revision: 369339
- remove duplicate define
- create _pkglibexecdir in sub pkgs

* Sun Jan 13 2013 barjac <barjac> 3.5.0.16-3.mga3
+ Revision: 361855
- fix build (libexec)
+ umeabot <umeabot>
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Thu Dec 13 2012 obgr_seneca <obgr_seneca> 3.5.0.16-1.mga3
+ Revision: 330107
- new version

* Wed Sep 26 2012 obgr_seneca <obgr_seneca> 3.5.0.15-1.mga3
+ Revision: 297936
- New version

* Mon May 28 2012 obgr_seneca <obgr_seneca> 3.5.0.13-1.mga3
+ Revision: 247902
- new version 3.5.0.13

* Tue Apr 03 2012 obgr_seneca <obgr_seneca> 3.5.0.12-1.mga2
+ Revision: 228276
- New version 3.5.0.12

* Fri Mar 09 2012 obgr_seneca <obgr_seneca> 3.5.0.11-2.mga2
+ Revision: 222038
-changed x2goagent wrapper setup

* Thu Mar 01 2012 obgr_seneca <obgr_seneca> 3.5.0.11-1.mga2
+ Revision: 216547
- removed unneeded BR on x11-devel
- switched upstream to x2go
- parts of the spec borrowed from openSUSE
- added x2goagent wrapper arround nxagent
- use redistributed source by x2go instead of nomachine source od nxagent

* Sun Jan 29 2012 obgr_seneca <obgr_seneca> 3.5.0-2.mga2
+ Revision: 202856
- filtered provides so other packages are not confused (Bug #4325)

* Sat Jan 28 2012 obgr_seneca <obgr_seneca> 3.5.0-1.mga2
+ Revision: 202719
- spec file changes taken mainly from fedora spec
- added nxscripts
- new version 3.5.0
- added png-1.5 patch
- imported package nx


* Fri Apr 16 2010 Funda Wang <fwang@mandriva.org> 3.3.0-3mdv2010.1
+ Revision: 535271
- rebuild

* Sat Aug 22 2009 Funda Wang <fwang@mandriva.org> 3.3.0-2mdv2010.0
+ Revision: 419581
- fix compile with gcc 4.4

  + Emmanuel Blindauer <blindauer@mandriva.org>
    - update to 3.3.0-6

* Thu Mar 05 2009 Guillaume Rousse <guillomovitch@mandriva.org> 3.3.0-2mdv2009.1
+ Revision: 348884
- fix format errors

* Tue Dec 09 2008 Adam Williamson <awilliamson@mandriva.org> 3.3.0-1mdv2009.1
+ Revision: 312039
- new license policy
- use rpm macros not $RPM_*
- drop unnecessary %%defines
- new release 3.3.0

* Fri Sep 05 2008 Adam Williamson <awilliamson@mandriva.org> 3.2.0-4mdv2009.0
+ Revision: 280995
- fix a typo
- remove now unneeded patches
- remove everything related to nxdesktop and nxviewer (these are dropped)

* Fri Aug 08 2008 Thierry Vignaud <tv@mandriva.org> 3.2.0-3mdv2009.0
+ Revision: 268318
- rebuild early 2009.0 package (before pixel changes)

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

* Sat Jun 07 2008 Emmanuel Blindauer <blindauer@mandriva.org> 3.2.0-2mdv2009.0
+ Revision: 216667
- updated to latest release

* Thu Apr 17 2008 Emmanuel Blindauer <blindauer@mandriva.org> 3.2.0-1mdv2009.0
+ Revision: 195059
- update to 3.2.0
- update to 3.2.0

* Tue Mar 25 2008 Emmanuel Blindauer <blindauer@mandriva.org> 3.1.0-4mdv2008.1
+ Revision: 189986
- updated to latest tarballs from nomachine, fixes several CVE related to xorg

* Mon Feb 18 2008 Thierry Vignaud <tv@mandriva.org> 3.1.0-3mdv2008.1
+ Revision: 171004
- rebuild
- fix "foobar is blabla" summary (=> "blabla") so that it looks nice in rpmdrake

* Tue Jan 29 2008 Emmanuel Blindauer <blindauer@mandriva.org> 3.1.0-2mdv2008.1
+ Revision: 159655
- update nx-X11 to 3.1.0-3

* Sun Jan 27 2008 Emmanuel Blindauer <blindauer@mandriva.org> 3.1.0-1mdv2008.1
+ Revision: 158607
- Fix compilation on x86_64
- rediff patch
- revert nx directory and re-user X11-nx name
  rediff patch0
- fix buildrequires
- updated sources
- Updated to 3.1.0, including Xcompshad

* Fri Dec 21 2007 Olivier Blin <oblin@mandriva.com> 2.1.0-1mdv2008.1
+ Revision: 136633
- restore BuildRoot

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request


* Tue Jan 02 2007 Emmanuel Blindauer <blindauer@mandriva.org> 2.1.0-1mdv2007.0
+ Revision: 103403
- fix x86_64 build (patch 4)
- 2.1.0 release

  + Jérôme Soyer <saispo@mandriva.org>
    - Import nx

* Sun Aug 27 2006 Couriousous <couriousous@mandriva.org> 2.0.0-1mdv2007.0
- 2.0.0
- Rediff patches

* Fri Dec 16 2005 Couriousous <couriousous@mandriva.org> 1.5.0-4mdk
- Sync with NoMachine NX 1.5 release

* Tue Oct 04 2005 Nicolas Lécureuil <neoclust@mandriva.org> 1.5.0-3mdk
- BuildRequires fix

* Sun Aug 21 2005 Couriousous <couriousous@mandriva.org> 1.5.0-2mdk
- Sync with NoMachine NX 1.5 release

* Sun Jul 24 2005 Couriousous <couriousous@mandriva.org> 1.5.0-1mdk
- 1.5
- Rediff some patch
- Patch to fix compilation with gcc4

* Fri Feb 11 2005 Couriousous <couriousous@mandrake.org> 1.4.0-3mdk
- Update nx-X11 (fix security bug)
- Various others updates
- Remove patch 4 & 5, fixed upstream

* Sun Jan 30 2005 Couriousous <couriousous@mandrake.org> 1.4.0-2mdk
- Update current 1.4 release
- Some spec fix
- Sync with debian patch
- x86_64 fix

* Fri Nov 12 2004 Couriousous <couriousous@zarb.org> 1.4.0-1mdk
- First Mandrakelinux release
- Take some fix from debian package
- Take doc from suse package
- Patch from Fabian Franz for gcc 3.4

